diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/tdmt-ff-mac-scheduler.h ns-3.39/src/lte/model/tdmt-ff-mac-scheduler.h
--- ns-3.38/src/lte/model/tdmt-ff-mac-scheduler.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/tdmt-ff-mac-scheduler.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,38 +21,22 @@
 #ifndef TDMT_FF_MAC_SCHEDULER_H
 #define TDMT_FF_MAC_SCHEDULER_H
 
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/ff-mac-scheduler.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ffr-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "ff-mac-scheduler.h"
+#include "lte-amc.h"
+#include "lte-common.h"
+#include "lte-ffr-sap.h"
+
 #include <ns3/nstime.h>
 
 #include <map>
 #include <set>
 #include <vector>
 
-// value for SINR outside the range defined by FF-API, used to indicate that there
-// is no CQI for this element
-#define NO_SINR -5000
-
-#define HARQ_PROC_NUM 8
-#define HARQ_DL_TIMEOUT 11
-
 namespace ns3
 {
 
-typedef std::vector<uint8_t> DlHarqProcessesStatus_t;
-typedef std::vector<uint8_t> DlHarqProcessesTimer_t;
-typedef std::vector<DlDciListElement_s> DlHarqProcessesDciBuffer_t;
-typedef std::vector<std::vector<struct RlcPduListElement_s>>
-    RlcPduList_t;                                           // vector of the LCs and layers per UE
-typedef std::vector<RlcPduList_t> DlHarqRlcPduListBuffer_t; // vector of the 8 HARQ processes per UE
-
-typedef std::vector<UlDciListElement_s> UlHarqProcessesDciBuffer_t;
-typedef std::vector<uint8_t> UlHarqProcessesStatus_t;
-
 /**
  * \ingroup ff-api
  * \brief Implements the SCHED SAP and CSCHED SAP for a Time Domain Maximize Throughput scheduler
@@ -115,36 +99,31 @@
      * \brief CSched cell config request
      * \param params FfMacCschedSapProvider::CschedCellConfigReqParameters
      */
-    void DoCschedCellConfigReq(
-        const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
+    void DoCschedCellConfigReq(const FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
 
     /**
      * \brief CSched UE config request
      * \param params FfMacCschedSapProvider::CschedUeConfigReqParameters
      */
-    void DoCschedUeConfigReq(
-        const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
+    void DoCschedUeConfigReq(const FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
 
     /**
      * \brief CSched LC config request
      * \param params FfMacCschedSapProvider::CschedLcConfigReqParameters
      */
-    void DoCschedLcConfigReq(
-        const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
+    void DoCschedLcConfigReq(const FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
 
     /**
      * \brief CSched LC release request
      * \param params FfMacCschedSapProvider::CschedLcReleaseReqParameters
      */
-    void DoCschedLcReleaseReq(
-        const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
+    void DoCschedLcReleaseReq(const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
 
     /**
      * \brief CSched UE release request
      * \param params FfMacCschedSapProvider::CschedUeReleaseReqParameters
      */
-    void DoCschedUeReleaseReq(
-        const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
+    void DoCschedUeReleaseReq(const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
 
     //
     // Implementation of the SCHED API primitives
@@ -155,77 +134,70 @@
      * \brief Sched DL RLC buffer request
      * \param params FfMacSchedSapProvider::SchedDlRlcBufferReqParameters
      */
-    void DoSchedDlRlcBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
+    void DoSchedDlRlcBufferReq(const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
 
     /**
      * \brief Sched DL paging buffer request
      * \param params FfMacSchedSapProvider::SchedDlPagingBufferReqParameters
      */
     void DoSchedDlPagingBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
+        const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
 
     /**
      * \brief Sched DL MAC buffer request
      * \param params FfMacSchedSapProvider::SchedDlMacBufferReqParameters
      */
-    void DoSchedDlMacBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
+    void DoSchedDlMacBufferReq(const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
 
     /**
      * \brief Sched DL trigger request
      * \param params FfMacSchedSapProvider::SchedDlTriggerReqParameters
      */
-    void DoSchedDlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
+    void DoSchedDlTriggerReq(const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
 
     /**
      * \brief Sched DL RACH info request
      * \param params FfMacSchedSapProvider::SchedDlRachInfoReqParameters
      */
-    void DoSchedDlRachInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
+    void DoSchedDlRachInfoReq(const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
 
     /**
      * \brief Sched DL CQI info request
      * \param params FfMacSchedSapProvider::SchedDlCqiInfoReqParameters
      */
-    void DoSchedDlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
+    void DoSchedDlCqiInfoReq(const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
 
     /**
      * \brief Sched UL trigger request
      * \param params FfMacSchedSapProvider::SchedUlTriggerReqParameters
      */
-    void DoSchedUlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
+    void DoSchedUlTriggerReq(const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
 
     /**
      * \brief Sched UL noise interference request
      * \param params FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters
      */
     void DoSchedUlNoiseInterferenceReq(
-        const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
 
     /**
      * \brief Sched UL SR info request
      * \param params FfMacSchedSapProvider::SchedUlSrInfoReqParameters
      */
-    void DoSchedUlSrInfoReq(const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
+    void DoSchedUlSrInfoReq(const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
 
     /**
      * \brief Sched UL MAC control info request
      * \param params FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters
      */
     void DoSchedUlMacCtrlInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
 
     /**
      * \brief Sched UL CQI info request
      * \param params FfMacSchedSapProvider::SchedUlCqiInfoReqParameters
      */
-    void DoSchedUlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
+    void DoSchedUlCqiInfoReq(const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
 
     /**
      * \brief Get RBG size function
@@ -391,9 +363,9 @@
         m_ulHarqProcessesDciBuffer; ///< UL HARQ process DCI buffer
 
     // RACH attributes
-    std::vector<struct RachListElement_s> m_rachList; ///< RACH list
-    std::vector<uint16_t> m_rachAllocationMap;        ///< RACH allocation map
-    uint8_t m_ulGrantMcs;                             ///< MCS for UL grant (default 0)
+    std::vector<RachListElement_s> m_rachList; ///< RACH list
+    std::vector<uint16_t> m_rachAllocationMap; ///< RACH allocation map
+    uint8_t m_ulGrantMcs;                      ///< MCS for UL grant (default 0)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/tdtbfq-ff-mac-scheduler.cc ns-3.39/src/lte/model/tdtbfq-ff-mac-scheduler.cc
--- ns-3.38/src/lte/model/tdtbfq-ff-mac-scheduler.cc	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/tdtbfq-ff-mac-scheduler.cc	2023-07-05 14:23:48.017428200 -0700
@@ -18,15 +18,17 @@
  * Modification: Dizhi Zhou <dizhi.zhou@gmail.com>    // modify codes related to downlink scheduler
  */
 
+#include "tdtbfq-ff-mac-scheduler.h"
+
+#include "lte-amc.h"
+#include "lte-vendor-specific-parameters.h"
+
 #include <ns3/boolean.h>
 #include <ns3/integer.h>
 #include <ns3/log.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-vendor-specific-parameters.h>
 #include <ns3/math.h>
 #include <ns3/pointer.h>
 #include <ns3/simulator.h>
-#include <ns3/tdtbfq-ff-mac-scheduler.h>
 
 #include <cfloat>
 #include <set>
@@ -165,7 +167,7 @@
 
 void
 TdTbfqFfMacScheduler::DoCschedCellConfigReq(
-    const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     // Read the subset of parameters used
@@ -178,7 +180,7 @@
 
 void
 TdTbfqFfMacScheduler::DoCschedUeConfigReq(
-    const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " RNTI " << params.m_rnti << " txMode "
                          << (uint16_t)params.m_transmissionMode);
@@ -224,7 +226,7 @@
 
 void
 TdTbfqFfMacScheduler::DoCschedLcConfigReq(
-    const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " New LC, rnti: " << params.m_rnti);
 
@@ -280,7 +282,7 @@
 
 void
 TdTbfqFfMacScheduler::DoCschedLcReleaseReq(
-    const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     for (std::size_t i = 0; i < params.m_logicalChannelIdentity.size(); i++)
@@ -307,7 +309,7 @@
 
 void
 TdTbfqFfMacScheduler::DoCschedUeReleaseReq(
-    const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -347,7 +349,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlRlcBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this << params.m_rnti << (uint32_t)params.m_logicalChannelIdentity);
     // API generated by RLC for updating RLC parameters on a LC (tx and retx queues)
@@ -372,7 +374,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlPagingBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -380,7 +382,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlMacBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -442,14 +444,8 @@
     {
         i = (i + 1) % HARQ_PROC_NUM;
     } while (((*itStat).second.at(i) != 0) && (i != (*it).second));
-    if ((*itStat).second.at(i) == 0)
-    {
-        return (true);
-    }
-    else
-    {
-        return (false); // return a not valid harq proc id
-    }
+
+    return (*itStat).second.at(i) == 0;
 }
 
 uint8_t
@@ -457,7 +453,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
 
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         return (0);
     }
@@ -528,7 +524,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf));
@@ -551,7 +547,7 @@
     rbgMap = m_ffrSapProvider->GetAvailableDlRbg();
     for (std::vector<bool>::iterator it = rbgMap.begin(); it != rbgMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbgAllocatedNum++;
         }
@@ -579,7 +575,7 @@
 
     for (std::vector<bool>::iterator it = ulRbMap.begin(); it != ulRbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             if (tmpMinBandwidth > maxContinuousUlBandwidth)
             {
@@ -608,7 +604,7 @@
     m_rachAllocationMap.resize(m_cschedCellConfig.m_ulBandwidth, 0);
     uint16_t rbStart = 0;
     rbStart = ffrRbStartOffset;
-    std::vector<struct RachListElement_s>::iterator itRach;
+    std::vector<RachListElement_s>::iterator itRach;
     for (itRach = m_rachList.begin(); itRach != m_rachList.end(); itRach++)
     {
         NS_ASSERT_MSG(m_amc->GetUlTbSizeFromMcs(m_ulGrantMcs, m_cschedCellConfig.m_ulBandwidth) >
@@ -650,7 +646,7 @@
             m_rachAllocationMap.at(i) = (*itRach).m_rnti;
         }
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // generate UL-DCI for HARQ retransmissions
             UlDciListElement_s uldci;
@@ -715,12 +711,12 @@
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
     }
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         // Ignore HARQ feedback
         m_dlInfoListBuffered.clear();
     }
-    std::vector<struct DlInfoListElement_s> dlInfoListUntxed;
+    std::vector<DlInfoListElement_s> dlInfoListUntxed;
     for (std::size_t i = 0; i < m_dlInfoListBuffered.size(); i++)
     {
         std::set<uint16_t>::iterator itRnti = rntiAllocated.find(m_dlInfoListBuffered.at(i).m_rnti);
@@ -811,7 +807,7 @@
             bool free = true;
             for (std::size_t j = 0; j < dciRbg.size(); j++)
             {
-                if (rbgMap.at(dciRbg.at(j)) == true)
+                if (rbgMap.at(dciRbg.at(j)))
                 {
                     free = false;
                     break;
@@ -839,7 +835,7 @@
                 std::vector<bool> rbgMapCopy = rbgMap;
                 while ((j < dciRbg.size()) && (startRbg != rbgId))
                 {
-                    if (rbgMapCopy.at(rbgId) == false)
+                    if (!rbgMapCopy.at(rbgId))
                     {
                         rbgMapCopy.at(rbgId) = true;
                         dciRbg.at(j) = rbgId;
@@ -910,7 +906,7 @@
             }
             for (std::size_t k = 0; k < (*itRlcPdu).second.at(0).at(dci.m_harqProcess).size(); k++)
             {
-                std::vector<struct RlcPduListElement_s> rlcPduListPerLc;
+                std::vector<RlcPduListElement_s> rlcPduListPerLc;
                 for (std::size_t j = 0; j < nLayers; j++)
                 {
                     if (retx.at(j))
@@ -1080,7 +1076,7 @@
         double metric =
             (((double)(*it).second.counter) / ((double)(*it).second.tokenGenerationRate));
 
-        if (firstRnti == true)
+        if (firstRnti)
         {
             metricMax = metric;
             itMax = it;
@@ -1106,12 +1102,12 @@
         std::vector<uint16_t> tempMap;
         for (int i = 0; i < rbgNum; i++)
         {
-            if (rbgMap.at(i) == true)
+            if (rbgMap.at(i))
             { // this RBG is allocated in RACH procedure
                 continue;
             }
 
-            if ((m_ffrSapProvider->IsDlRbgAvailableForUe(i, (*itMax).first)) == false)
+            if (!m_ffrSapProvider->IsDlRbgAvailableForUe(i, (*itMax).first))
             {
                 continue;
             }
@@ -1232,7 +1228,7 @@
                  ((*itBufReq).second.m_rlcRetransmissionQueueSize > 0) ||
                  ((*itBufReq).second.m_rlcStatusPduSize > 0)))
             {
-                std::vector<struct RlcPduListElement_s> newRlcPduLe;
+                std::vector<RlcPduListElement_s> newRlcPduLe;
                 for (uint8_t j = 0; j < nLayer; j++)
                 {
                     RlcPduListElement_s newRlcEl;
@@ -1244,7 +1240,7 @@
                     UpdateDlRlcBufferInfo(newDci.m_rnti,
                                           newRlcEl.m_logicalChannelIdentity,
                                           newRlcEl.m_size);
-                    if (m_harqOn == true)
+                    if (m_harqOn)
                     {
                         // store RLC PDU list for HARQ
                         std::map<uint16_t, DlHarqRlcPduListBuffer_t>::iterator itRlcPdu =
@@ -1274,7 +1270,7 @@
 
         newEl.m_dci = newDci;
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // store DCI for HARQ
             std::map<uint16_t, DlHarqProcessesDciBuffer_t>::iterator itDci =
@@ -1328,7 +1324,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlRachInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -1337,7 +1333,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedDlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     m_ffrSapProvider->ReportDlCqiInfo(params);
@@ -1432,7 +1428,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedUlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " UL - Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf) << " size " << params.m_ulInfoList.size());
@@ -1458,7 +1454,7 @@
 
     for (std::vector<bool>::iterator it = rbMap.begin(); it != rbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbAllocatedNum++;
         }
@@ -1477,7 +1473,7 @@
         }
     }
 
-    if (m_harqOn == true)
+    if (m_harqOn)
     {
         //   Process UL HARQ feedback
         for (std::size_t i = 0; i < params.m_ulInfoList.size(); i++)
@@ -1517,7 +1513,7 @@
                 bool free = true;
                 for (int j = dci.m_rbStart; j < dci.m_rbStart + dci.m_rbLen; j++)
                 {
-                    if (rbMap.at(j) == true)
+                    if (rbMap.at(j))
                     {
                         free = false;
                         NS_LOG_INFO(this << " BUSY " << j);
@@ -1658,12 +1654,12 @@
             bool free = true;
             for (int j = rbAllocated; j < rbAllocated + rbPerFlow; j++)
             {
-                if (rbMap.at(j) == true)
+                if (rbMap.at(j))
                 {
                     free = false;
                     break;
                 }
-                if ((m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first)) == false)
+                if (!m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first))
                 {
                     free = false;
                     break;
@@ -1780,7 +1776,7 @@
         ret.m_dciList.push_back(uldci);
         // store DCI for HARQ_PERIOD
         uint8_t harqId = 0;
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             std::map<uint16_t, uint8_t>::iterator itProcId;
             itProcId = m_ulHarqCurrentProcessId.find(uldci.m_rnti);
@@ -1835,21 +1831,21 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedUlNoiseInterferenceReq(
-    const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 TdTbfqFfMacScheduler::DoSchedUlSrInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 TdTbfqFfMacScheduler::DoSchedUlMacCtrlInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -1892,7 +1888,7 @@
 
 void
 TdTbfqFfMacScheduler::DoSchedUlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     // retrieve the allocation for this subframe
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/tdtbfq-ff-mac-scheduler.h ns-3.39/src/lte/model/tdtbfq-ff-mac-scheduler.h
--- ns-3.38/src/lte/model/tdtbfq-ff-mac-scheduler.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/tdtbfq-ff-mac-scheduler.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,37 +21,21 @@
 #ifndef TDTBFQ_FF_MAC_SCHEDULER_H
 #define TDTBFQ_FF_MAC_SCHEDULER_H
 
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/ff-mac-scheduler.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ffr-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "ff-mac-scheduler.h"
+#include "lte-amc.h"
+#include "lte-common.h"
+#include "lte-ffr-sap.h"
+
 #include <ns3/nstime.h>
 
 #include <map>
 #include <vector>
 
-// value for SINR outside the range defined by FF-API, used to indicate that there
-// is no CQI for this element
-#define NO_SINR -5000
-
-#define HARQ_PROC_NUM 8
-#define HARQ_DL_TIMEOUT 11
-
 namespace ns3
 {
 
-typedef std::vector<uint8_t> DlHarqProcessesStatus_t;
-typedef std::vector<uint8_t> DlHarqProcessesTimer_t;
-typedef std::vector<DlDciListElement_s> DlHarqProcessesDciBuffer_t;
-typedef std::vector<std::vector<struct RlcPduListElement_s>>
-    RlcPduList_t;                                           // vector of the LCs and layers per UE
-typedef std::vector<RlcPduList_t> DlHarqRlcPduListBuffer_t; // vector of the 8 HARQ processes per UE
-
-typedef std::vector<UlDciListElement_s> UlHarqProcessesDciBuffer_t;
-typedef std::vector<uint8_t> UlHarqProcessesStatus_t;
-
 /**
  *  Flow information
  */
@@ -132,36 +116,31 @@
      * \brief CSched cell config request
      * \param params FfMacCschedSapProvider::CschedCellConfigReqParameters
      */
-    void DoCschedCellConfigReq(
-        const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
+    void DoCschedCellConfigReq(const FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
 
     /**
      * \brief CSched UE config request
      * \param params FfMacCschedSapProvider::CschedUeConfigReqParameters
      */
-    void DoCschedUeConfigReq(
-        const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
+    void DoCschedUeConfigReq(const FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
 
     /**
      * \brief CSched LC config request
      * \param params FfMacCschedSapProvider::CschedLcConfigReqParameters
      */
-    void DoCschedLcConfigReq(
-        const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
+    void DoCschedLcConfigReq(const FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
 
     /**
      * \brief CSched LC release request
      * \param params FfMacCschedSapProvider::CschedLcReleaseReqParameters
      */
-    void DoCschedLcReleaseReq(
-        const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
+    void DoCschedLcReleaseReq(const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
 
     /**
      * \brief CSched UE release request
      * \param params FfMacCschedSapProvider::CschedUeReleaseReqParameters
      */
-    void DoCschedUeReleaseReq(
-        const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
+    void DoCschedUeReleaseReq(const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
 
     //
     // Implementation of the SCHED API primitives
@@ -172,77 +151,70 @@
      * \brief Sched DL RLC buffer request
      * \param params FfMacSchedSapProvider::SchedDlRlcBufferReqParameters
      */
-    void DoSchedDlRlcBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
+    void DoSchedDlRlcBufferReq(const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
 
     /**
      * \brief Sched DL paging buffer request
      * \param params FfMacSchedSapProvider::SchedDlPagingBufferReqParameters
      */
     void DoSchedDlPagingBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
+        const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
 
     /**
      * \brief Sched DL MAC buffer request
      * \param params FfMacSchedSapProvider::SchedDlMacBufferReqParameters
      */
-    void DoSchedDlMacBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
+    void DoSchedDlMacBufferReq(const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
 
     /**
      * \brief Sched DL trigger request
      * \param params FfMacSchedSapProvider::SchedDlTriggerReqParameters
      */
-    void DoSchedDlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
+    void DoSchedDlTriggerReq(const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
 
     /**
      * \brief Sched DL RACH info request
      * \param params FfMacSchedSapProvider::SchedDlRachInfoReqParameters
      */
-    void DoSchedDlRachInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
+    void DoSchedDlRachInfoReq(const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
 
     /**
      * \brief Sched DL CQI info request
      * \param params FfMacSchedSapProvider::SchedDlCqiInfoReqParameters
      */
-    void DoSchedDlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
+    void DoSchedDlCqiInfoReq(const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
 
     /**
      * \brief Sched UL trigger request
      * \param params FfMacSchedSapProvider::SchedUlTriggerReqParameters
      */
-    void DoSchedUlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
+    void DoSchedUlTriggerReq(const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
 
     /**
      * \brief Sched UL noise interference request
      * \param params FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters
      */
     void DoSchedUlNoiseInterferenceReq(
-        const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
 
     /**
      * \brief Sched UL SR info request
      * \param params FfMacSchedSapProvider::SchedUlSrInfoReqParameters
      */
-    void DoSchedUlSrInfoReq(const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
+    void DoSchedUlSrInfoReq(const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
 
     /**
      * \brief Sched UL MAC control info request
      * \param params FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters
      */
     void DoSchedUlMacCtrlInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
 
     /**
      * \brief Sched UL CQI info request
      * \param params FfMacSchedSapProvider::SchedUlCqiInfoReqParameters
      */
-    void DoSchedUlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
+    void DoSchedUlCqiInfoReq(const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
 
     /**
      * \brief Get RBG size
@@ -418,9 +390,9 @@
         m_ulHarqProcessesDciBuffer; ///< UL HARQ process DCI buffer
 
     // RACH attributes
-    std::vector<struct RachListElement_s> m_rachList; ///< RACH list
-    std::vector<uint16_t> m_rachAllocationMap;        ///< RACH allocation map
-    uint8_t m_ulGrantMcs;                             ///< MCS for UL grant (default 0)
+    std::vector<RachListElement_s> m_rachList; ///< RACH list
+    std::vector<uint16_t> m_rachAllocationMap; ///< RACH allocation map
+    uint8_t m_ulGrantMcs;                      ///< MCS for UL grant (default 0)
 };
 
 } // namespace ns3
